var _ = require('lodash'),
	mongoose = require('mongoose'),
	Schema = mongoose.Schema;

//	,
//	ObjectId = Schema.ObjectId

exports = module.exports = {
	getModel: function(mongoose) {
		"use strict";

		var collectionName = 'Person';
		var modelName = 'Person';

		return (function() {
			var model;

			if (_.isUndefined(model)) {

				var personSchema = new Schema({
					name: {
						first: {type: String, required: true},
						middle: String,
						last: {type: String, required: true}
					},
					active: {type: Boolean, default: true},
					createdOn: Date,
					updatedOn: Date
				}, {
					strict: true
				});

				personSchema.index({'name.first': 1, 'name.middle': 1, 'name.last': 1},{unique: true});


				personSchema.statics.getCollectionName = function getCollectionName() {
					return collectionName;
				};

				personSchema.statics.getModelName = function getModelName() {
					return modelName;
				};

				personSchema.statics.getName = function getName (fullName) {
						var a = fullName.split(' ');

						return {
							first: a[0],
							middle: a[1],
							last: a[2]
						};

				};

				mongoose.connection.collection(collectionName);
				model = mongoose.model(modelName, personSchema, collectionName);

			}
			return model;
		}());
	}
};

//
//	/**
//	 * deletes from the database the record corresponding to this person
//	 */
//	this.delete = function() {
//
//		return Q.ninvoke(
//			Person,
//			'update',
//			{_id: that._id, active: true},
//			{active: false, updatedOn: new Date()},
//			{multi:true}
//		);
//	};
//
//
//	/**
//	 * Get a person by id
//	 *
//	 * @param id {string}
//	 */
//	this.getById = function(id) {
//
////		if (!(id.length === 24 || id.length === 12)) {
////			callback('invalid id');
////			return;
////		}
//
//		return Q.ninvoke(
//			Person,
//			'find',
//			{_id: new ObjectID(id)}
//		);
//	};
//
////	this.setByName = function(name) {
////		that.getByName(name)
////			.then(function(items) {
////				return setPerson(items);
////			}
////		);
////	};
////
////	this.setById = function(id) {
////		that.getById(id)
////			.then(function(items) {
////				 return setPerson(items)
////			}
////		);
////	};
//
////	this.setPerson = function(items) {
////		var person = items[0];
////		that.isValid = items.length > 0 && person.active;
////		_.extend(that, person);
////		return Q.fcall(function() {
////			return person;
////		});
////	};
//
//	this.add = function(fullName) {
//		return that.getByName(fullName)
//			.then(function(items) {
//				if (items.length) {
//					return that.update(true);
//				} else {
//					return that.insert(fullName);
//				}
//			});
//	};
//
//	this.update = function(active) {
//		return Q.ninvoke(
//			Person,
//			'update',
//			{_id: that._id},
//			{active: active, updatedOn: new Date()}
//		)
//		.then(function(response) {
//			console.log('numberAffected: ' + response[0]);
//		});
//	};
//
//	this.insert = function(fullName) {
//		return Q.ninvoke(
//			Person,
//			'insert',
//			{
//				name: exports.getName(fullName),
//				active: true,
//				createdOn: new Date()
//			}
//		);
//	};
//
//
//
//
///**
// * Get a person by name
// *
// * @param fullName {string} should contain first, middle, and last names separated by spaces
// */
//	this.getByName = function getByName(fullName) {
//		return Q.ninvoke(
//			Person,
//			'find',
//			{
//				name: exports.getName(fullName)
//			}
//		);
//	};
//
//};